import { Vector3 } from "./Vector3";
/** A ray, consisting of an origin and a direction */
var Ray = /** @class */ (function () {
    function Ray(origin, direction) {
        this.origin = origin;
        this.direction = direction;
    }
    //#region Create / Init
    /** Convenience function for creating a Ray, cloning the parameters */
    Ray.create = function (origin, direction) {
        return {
            origin: Vector3.clone(origin),
            direction: Vector3.clone(direction),
        };
    };
    //#endregion Create / Init
    //#region Clone / Copy
    /** Convenience function for cloning a Ray */
    Ray.clone = function (ray) {
        return Ray.create(ray.origin, ray.direction);
    };
    return Ray;
}());
export { Ray };
